import TreeNode from './tree-node';
import { IPublicModelNode } from '@redhare/lowcode-types';
import { IOutlinePanelPluginContext, TreeMaster } from './tree-master';
export declare class Tree {
    private treeNodesMap;
    readonly id: string | undefined;
    readonly pluginContext: IOutlinePanelPluginContext;
    get root(): TreeNode | null;
    readonly treeMaster: TreeMaster;
    constructor(treeMaster: TreeMaster);
    setNodeSelected(nodeId: string): void;
    getTreeNode(node: IPublicModelNode): TreeNode;
    getTreeNodeById(id: string): TreeNode;
    expandAllAncestors(treeNode: TreeNode | undefined | null): void;
    expandAllDecendants(treeNode: TreeNode | undefined | null): void;
    collapseAllDecendants(treeNode: TreeNode | undefined | null): void;
}
